/*--- VIDTEST.C ----------------------------------------------


	Demonstrates usage of video control structure.

	(c) by MacSoft 1991

*/


#include "slick!.h"
#include <stdio.h>

char * modes[]= {
	"No EGA/VGA installed, ",
	"EGA (color)",
	"EGA (mono)",
	"PGC (color)",
	"VGA (mono)",
	"VGA (color)",
	"MCGA (color)",
	"MCGA (mono)"
};

void main(void)
{
unsigned int i;
/*
** Let the driver do the job...
*/
	_videoparm();

/*
** Version first.
*/
	printf("\nSLICK! version      : %s",wndversio());
/*
** Base is easy...
*/
	printf("\nScreen base segment : %04X",_videocblk.base);
	asm {
		push	di
		mov		di,0ffffh
		mov		es,di
		inc		di
		mov		ah,0feh
		int		10h
		pop		di
		mov		i,es
	}
	printf("\nDESQview screen     : %04X",i);
/*
** If DESQview is active, print it's version....
*/
	printf("\nDESQview status     : %s active",(DVactive())?"Currently":"Not");
	if (DVactive())
		printf("\nDESQview version    : %d.%d",DVactive()>>8,DVactive()&255);
/*
** Now some straightforward data from control structure...
*/
	printf("\nPhysical video mode : %d",_videocblk.mode);
	printf("\nColumns on screen   : %d",_videocblk.cols);
	printf("\nRows on screen      : %d",_videocblk.rows);
	printf("\nScan lines/char     : %d",_videocblk.scan);
	printf("\nAuto snow check     : %s",(_videocblk.snow&1)?"On":"Off");
	printf("\nActive visual page  : %d",_videocblk.page);
/*
** And now video system. First we print EGA/VGA mode, which is straight,
** after that we'll examine if we have EGA at all. If not, we'll check
** video mode to see if it is CGA or MONO card. Of course, we could
** also use the snow check flag which will be set for CGA.
*/
	printf("\nEGA/VGA mode        : ");
	printf("%s",modes[_videocblk.ega]);
	if (!_videocblk.ega)
		if (_videocblk.mode==7)
			printf("MONO or Hercules is active");
		else
			printf("CGA is active");
	printf("\nDOS heap available  : %ld bytes",_mycoreleft());
	printf("\n");
}
